function pij = ipole(p12,p13,p23)

% This function computes the coordinates of the image pole, p'23, 
% given the coordinates of the two poles, p12, p13, p23.

% pij is returned as the two component vector of the image pole.

r=sqrt((p23(1)-p12(1))^2+(p23(2)-p12(2))^2);
phi=atan2((p23(2)-p12(2)),(p23(1)-p12(1)));
beta=atan2((p13(2)-p12(2)),(p13(1)-p12(1)));
theta=beta-phi;
pij(1)=p12(1)+r*cos(phi+2*theta);
pij(2)=p12(2)+r*sin(phi+2*theta);


