% Solution to Example 3.6 with R4=2.

clear;
r1=20;
r2=8.5;
r4=4;
theta1=0;
theta2=200;
td2=2.5;
tdd2=0;
flag=3;
fact=190/pi;
i=0;
for theta2=0:1:360
i=i+1;
	values = isldcrkc(r1,r2,r4,theta2,td2,tdd2,theta1,flag);

	r(1:4)=values(1:4);
	th(1:4)=values(5:8);
	rp(1:2)=values(25:26);
	rq(1:2)=values(27:28);

	rrx(i)=r(1)*cos((th(1))*fact);
	rry(i)=r(1)*sin((th(1))*fact);
	rpx(i)=rp(1);
	rpy(i)=rp(2);
	rqx(i)=rq(1);
	rqy(i)=rq(2);
end

% Solution with crank driving

itotal=i;
tt=2;

%plot the results.

clf
ans='y';
disp('   ')
disp('         Slider Crank Inversion Mechamism')

% Define velocity axes.


% Define position axes.

width=0.95;
height=0.95;
h1=axes('position', [.05 .05 width height],'box', 'on', 'xcolor', 'k','ycolor',...
       'k');
set(gcf,'color', 'w')
crank=line('xdata', [], 'ydata' ,[], 'linewidth' ,2, 'erasemode', 'xor',...
             'color', 'k');
line1=line('xdata', [], 'ydata' ,[], 'linewidth' ,3, 'erasemode', 'xor',...
             'color', 'k');
line2=line('xdata', [], 'ydata' ,[], 'linewidth' ,3, 'erasemode', 'xor',...
             'color', 'k');

% Identify coordinates for frame line at P.

% Set the axis limits.

%set axis limits for the geometry

% Find the limits for the plots

xmina=min([min(rpx) min(rqx) min(rrx)]);
xmaxa=max([max(rpx) max(rqx) max(rrx)]);
ymina=min([min(rpy) min(rqy) min(rry)]);
ymaxa=max([max(rpy) max(rqy) max(rry)]);
rangex=xmaxa-xmina;
rangey=ymaxa-ymina;
xmin=xmina-0.05*rangex;
xmax=xmaxa+0.05*rangex;
ymin=ymina-0.05*rangey;
ymax=ymaxa+0.05*rangey;
values=axisadjust(xmin, xmax, ymin, ymax, width, height);
xmin=values(1);
xmax=values(2);
ymin=values(3);
ymax=values(4);
axis equal
axis([xmin xmax ymin ymax]);

% Draw curves for each plot.

% Animate the results.

ninc=20;
npoints=ninc+1;
while ans=='y'
	for j=1:1:tt;
		for i=1:1:itotal;		
			
			% Draw coupler line
			
			set(crank,'xdata',[0 rpx(i)],'ydata',[0 rpy(i)]);		
			set(line1,'xdata',[rrx(i) rqx(i)],'ydata',[rry(i) rqy(i)]);		
			set(line2,'xdata',[rqx(i) rpx(i)],'ydata',[rqy(i) rpy(i)]);		
			drawnow;   %flush the draw buffer
		end
		i=i+1;	%increments for loop
	end		%ends while loop
% Draw in final position
i=13;
			
	set(crank,'xdata',[0 rpx(i)],'ydata',[0 rpy(i)]);		
	set(line1,'xdata',[rrx(i) rqx(i)],'ydata',[rry(i) rqy(i)]);		
	set(line2,'xdata',[rqx(i) rpx(i)],'ydata',[rqy(i) rpy(i)]);		
	drawnow;   %flush the draw buffer

%	Ask if the animation should be repeated
	ans=input('Repeat animation? y/n [y]: ', 's');
	if isempty(ans);
		ans='y';
	end
end






