% Matlab function to find the angle x given the involute function of x

function x = inverse_inv(y)

% This function routine finds the angle x given the involute function 
% of x, where inv(x) = y = tan(x)-x.  acc is the accuracy desired (typically 0.000001). 
% The input value y must be between 0 and 1.

% The result is returned in x which is in degrees.  The solution is generated
% using a modified exhaustive search.   

% start by bounding the solution.

dx=0.01;
x1=0;
x0=0;
flag=0;
y0=0;
error=0;
funstop=0;
for i=1:1:8
	x1=x1-dx;
	dx=dx/10;
	while flag==0
		x0=x1;
		x1=x1+dx;
		y1=tan(x1)-x1;
		if y<=y1
			flag=1;
		end
		if y>y1
			y0=y1;
		end
		if x1>1;
			flag=1;
			error=1;
		end
	end
	flag=0;
end

% No solution was found

if error==1
	disp ('  ******** NO SOLUTION FOUND, CHECK VALUE FOR inv(x) **********')
	funstop=1;
end
x=x1*180/pi;

