function [theta,thi,yl]=precout(x,xl,phetal,phil,ansfun,ys, yf, yinput)

% Function file that calculates the output,y, the output angle, phi, and the 
% input angle, pheta, at the precision points 

%Variables
%   x=x values at the precision points
%   xl=limiting x values
%   phetal=limiting crank angles (rad)
%   phil=limiting rocker angles (rad)
%   y=y values at the precision points
%   yinput = y values at the precision points
%   ys = lower imit for y
%   yf = upper limit for y
%   yl=limiting y values, yl = [ys, yf]
%   theta=crank angles at the precision points (rad)
%   thi=rocker angles at the precision points (rad)
%   ansfun = flag indicating if y is to be computed.

%Program

if ansfun== 'n'; y=funct(x); end
if ansfun== 'n'; yl=funct(xl); end
if ansfun~= 'n'; y=yinput; end
if ansfun~= 'n'; yl=[ys yf]; end
theta=((phetal(2)-phetal(1)).*(x-xl(1)))./(xl(2)-xl(1))+phetal(1);
thi=((phil(2)-phil(1)).*(y-yl(1)))./(yl(2)-yl(1))+phil(1);
