function [coords] = rect(length,height,x0,y0,theta,flag)

% This function determines the coordinates of a series of points defining 
% a rectangle. The number of points stored is 5.  

% The input values are:

%length  = lenght of rectangle
%height  = height of rectangle
%x0      = x coordinate of center or bottom left corner of rectangle
%y0      = y coordinate of center or bottom left corner of rectangle
%theta 	 = rotation angle relative to the horizontal x axis (degrees)
%flag    = flag indicating if the rotation and (x0, y0) are defined
%          relative to the center (flag = 0) or to the bottom left hand
%			     corner of the rectangle. 

% The results are returned in the vector "coords".  The answers are 
% stored in values according to the following:

%values (i,1) = x coordinates of rectangle
%values (i,2) = y coordinates of rectangle

% find the coordinates of the points.

i=0;
fact=pi/180;
thetar=fact*theta;
dx=length/2;
dy=height/2;

i=i+1;
xtemp(i)=-dx;
ytemp(i)=-dy;
i=i+1;
xtemp(i)=dx;
ytemp(i)=-dy;
i=i+1;
xtemp(i)=dx;
ytemp(i)=dy;
i=i+1;
xtemp(i)=-dx;
ytemp(i)=dy;
i=i+1;
xtemp(i)=-dx;
ytemp(i)=-dy;

% rotate coordinates, translate by (x0, y0) and store coordinates in "coords"

c=cos(thetar);
s=sin(thetar);
xtrans=x0;
ytrans=y0;
if flag~=0
	xtrans=x0+dx;
	ytrans=y0+dy;
end

for j=1:1:5
		coords(j,1)=xtrans+xtemp(j)*c-ytemp(j)*s;
		coords(j,2)=ytrans+xtemp(j)*s+ytemp(j)*c;
end
