function [Qstart, Qstop]=sc_angle_limits_co(r2,r3,r4,Q1)

% Function file that calculates the initial and final angles for 
% slider-crank linkage when the coupler is the driver.

% Variables
%   r2=crank length (cm)
%   r3=coupler length (cm)
%   r4=rocker length (cm)
%   Q1=frame angle(deg)
%   Qstart=initial crank angle (deg)
%   Qstop=final crank angle (deg)

%Program

Qstart=0;
Qstop=360;
fact=180/pi;
if r2<(r3+abs(r4))
	if r2-r4<=r3 & r4>=0
		Qstart=Q1+fact*asin((r4-r2)/r3);
		Qstop=Q1+180-fact*asin((r4-r2)/r3);
	end
	if r2+r4<r3 & r4>=0
		Qstart=Q1+fact*asin((r4-r2)/r3);
		Qstop=Q1+fact*asin((r4+r2)/r3);
	end
	if r2+r4<=r3 & r4<=0
		Qstart=Q1-180-fact*asin((r4+r2)/r3);
		Qstop=Q1+fact*asin((r4+r2)/r3);
	end
	if r2-r4<r3 & r4<=0
		Qstart=Q1+fact*asin((r4-r2)/r3);
		Qstop=Q1+fact*asin((r4+r2)/r3);
	end
end
range=Qstop-Qstart;
Qstart=Qstart+0.00000001*range;
Qstop=Qstop-0.00000001*range;
