function [Qstart, Qstop]=sc_angle_limits_cr(r2,r3,r4,Q1)

% Function file that calculates the initial and final angle for four-bar
% linkage when the crank is the driver.

% Variables
%   r2=crank length (cm)
%   r3=coupler length (cm)
%   r4=rocker length (cm)
%   Q1=frame angle(deg)
%   Qstart=initial crank angle (deg)
%   Qstop=final crank angle (deg)

%Program

Qstart=0;
Qstop=360;
fact=180/pi;
if r3+r4<r2 & r4>=0 & r3>r4
	Qstart=Q1+fact*asin((r4-r3)/r2);
	Qstop=Q1+fact*asin((r4+r3)/r2);
end
if r3+r4>=r2 & r4>=r3
	Qstart=Q1+fact*asin((r4-r3)/r2);
	Qstop=Q1+180-fact*asin((r4-r3)/r2);
end
if r3-r4<r2 & r4<=0 & r3>-r4
	Qstart=Q1+fact*asin((r4-r3)/r2);
	Qstop=Q1+fact*asin((r4+r3)/r2);
end
if r3-r4>=r2 & r4<=0 & -r4>r3
	Qstart=Q1-180-fact*asin((r4+r3)/r2);
	Qstop=Q1+fact*asin((r4+r3)/r2);
end
range=Qstop-Qstart;
Qstart=Qstart+0.00000001*range;
Qstop=Qstop-0.00000001*range;
