function [rstart, rstop]=sc_angle_limits_sl(r2,r3,r4,Q1)

% Function file that calculates the initial and final distance for
% the slider travel for a slider-crank mechanism driven by the 
% slider.

% Variables
%   r2=crank length
%   r3=coupler length
%   r4=rocker length
%   Q1=frame angle(deg)
%   rstart=initial slider displacement 
%   rstop=final slider displacement 

%Program

rstart=0;
rstop=0;
if abs(r2-r3)>=r4
	arg1=(r2-r3)^2-r4^2;
	if arg1>=0
		rstart=sqrt(arg1);
	end
	arg2=(r2+r3)^2-r4^2;
	rstop=sqrt(arg2);
end	
if abs(r2-r3)<r4
	arg2=(r2+r3)^2-r4^2;
	if arg2>=0
		rstart=-sqrt(arg2);
		rstop=sqrt(arg2);
	end
end
range=rstop-rstart;
rstart=rstart+0.00000001*range;
rstop=rstop-0.00000001*range;

